;; Example Dezyne IDE init for Emacs-like look and feel; copy to ~/.dezyne.scm

;;(frame-set-size 800 600)
;;(frame-set-size) ;; maximum size, but not full screen

(emacs-mode)
(menu-bar-mode)
(tool-bar-mode)

(define (find-file-at-point)
  (let* ((start (point))
         (str (buffer-substring start (point-max)))
         (char-set:file-name (string->char-set "/.-+" char-set:letter+digit))
         (file-name-boundary (char-set-complement char-set:file-name))
         (end (or (string-index str file-name-boundary)
                  (string-length str)))
         (file-at-point (substring str 0 end)))
    (if (and (string? file-at-point) (not (string-null? file-at-point))) (visit-file file-at-point)
        (find-file))))

(define-key global-key-map "C-z C-f" find-file-at-point)
