(define-module (ide command)
  #:export (define-interactive
            set-command-properties!
            command?))

(define* (set-command-properties! proc #:optional (name #f))
  (let ((cname (or name (procedure-name proc) #f)))
    (set-procedure-property! proc 'command-name cname)))

(define-syntax define-interactive
  (syntax-rules ()
    ((define-interactive (name . args) . body)
     (begin (define* (name . args)
              . body)
            (set-command-properties! name)
            (export name)))
    ((define-interactive name value)
     (begin (define name value)
            (set-command-properties! name)
            (export name)))))

(define (command? x)
  (and (procedure? x)
       (assq-ref (procedure-properties x) 'command-name)))
