(define-module (ide dzn)
  #:use-module (ide command)
  #:use-module (ide console)
  #:use-module (ide interface))

(define-interactive (dzn-explore)
  "Explore main Dezyne model in editor.

Runs dzn-explore in console."
  (let ((status (run-shell-command "dzn-explore --help")))
    (if (not (zero? status)) (message (format #f "dzn-explore failed: ~a" status))
        (let ((file-name (buffer-file-name)))
          (if (string-null? file-name) (message "no dezyne file loaded")
              (run-shell-command-async (string-append "dzn-explore " (basename file-name))))))))
