(define-module (ide text)
  #:use-module (ice-9 optargs)
  #:use-module (oop goops)
  #:use-module (emacsy emacsy)
  #:use-module (emacsy buffer)
  #:use-module (emacsy text)
  #:use-module (emacsy minibuffer)
  #:use-module (emacsy core)
  ;; #:use-module (emacsy window)
  #:export (<scintilla-buffer>))

(define-class <scintilla-buffer> (<text-buffer>)
  (view #:accessor buffer-view #:init-form #f ;;(make-scintilla)
        ))

;;(define scintilla-buffer-view buffer-view)

(define-method (buffer:buffer-string (buffer <scintilla-buffer>))
  (scintilla-get-string (scintilla-current-buffer)))

(define-method (buffer:goto-char (buffer <scintilla-buffer>) pos)
  (scintilla-goto-char (scintilla-current-buffer) pos)
  (scintilla-point (scintilla-current-buffer)))

(define-method (buffer:point (buffer <scintilla-buffer>))
  (scintilla-point (scintilla-current-buffer)))

(define-method (buffer:point-min (buffer <scintilla-buffer>))
  (scintilla-point-min (scintilla-current-buffer)))

(define-method (buffer:point-max (buffer <scintilla-buffer>))
  (scintilla-point-max (scintilla-current-buffer)))

(define-method (buffer:set-mark (buffer <scintilla-buffer>) pos)
  (scintilla-set-mark (scintilla-current-buffer) pos))

(define-method (buffer:mark (buffer <scintilla-buffer>))
  (scintilla-mark (scintilla-current-buffer)))

(define-method (buffer:char-after (buffer <scintilla-buffer>) pos)
  (scintilla-char-after (scintilla-current-buffer) pos))

(define-method (buffer:insert-string (buffer <scintilla-buffer>) string)
  (scintilla-insert-string! (scintilla-current-buffer) string))

(define-method (buffer:insert-char (buffer <scintilla-buffer>) char)
  (scintilla-insert-char! (scintilla-current-buffer) char))

(define-method (buffer:delete-char (buffer <scintilla-buffer>) n)
  (let ((beg (point)))
    (forward-char n)
    (delete-region beg (point))))

(define-method (buffer:delete-region (buffer <scintilla-buffer>) start end)
  (scintilla-delete-region! (scintilla-current-buffer) start end))

(define-method (buffer:recenter (buffer <scintilla-buffer>) position)
  (scintilla-recenter (scintilla-current-buffer) position))

(define-public fundamental-mode (make <mode> #:mode-name "fundamental" #:mode-map fundamental-map))

(define-interactive (make-text-buffer #:optional (name "*scratch*"))
  (define (on-enter)
    (format (current-error-port) "TODO: Setting scintilla to ~a~%" (scintilla-current-buffer))
    ;; (format (current-error-port) "(selected-window) ~a~%" (selected-window))
    ;; (format (current-error-port) "(user-data) ~a~%" (user-data (selected-window)))
    ;; (let ((ui-data (user-data (selected-window)))
    ;;       (buffer (current-buffer)))
    ;;   (set! (window-buffer (selected-window)) buffer)
    ;;   (when ui-data
    ;;     (set-view! ui-data (scintilla-buffer-view buffer) #t))))
  #t )

  (let ((buffer (make <scintilla-buffer> #:name name #:buffer-modes `(,fundamental-mode))))
    (add-hook! (buffer-enter-hook buffer) on-enter)
    (add-buffer! buffer)
    buffer))

(module-define! (resolve-module '(emacsy core)) 'make-text-buffer make-text-buffer)
